Subject: [weirds] Category of Objects

From: Olaf Kolkman <[email-masked]>
Date: Wed, 11 Jul 2012 22:11:54 +0200

Colleagues,

(Also see mail with subject: "Setting the WEIRDS IETF 84 agenda")

The thread on extensibility[1] got me thinking. I am trying to work out how the WG approach this problem and get to guiding principles. I do not care what the guiding principles are but I would want to prevent a situation where we redo the same discussion each time the extensibility issue comes to the table. 

So why don't we try to make a qualification of objects, we can later try to map various objects into these classes.

I can think of tree or four types of objects:

* Core Objects.

The types of objects that are supported by the 'core protocol'. One can think in terms of MUST and MAYs, if not in the RFC2119 sense than at least in the sense that you may reasonably expect them to be implemented to have a usable protocol in the first place.

You may want to version the protocol (e.g. through mediatype) if the set of core objects changes. 

* Standardized Extension Objects.

This is the type of object that might not be in wide use but for which global standardization is useful. The social media handle comes to mind, those are objects with similar semantics that might benefit from uniform and standardized representation (e.g. all having the same internationalization properties).

* Private Extension Objects (accessible and inaccessible).

If the sender and receiver are part of a small set of users that have knowledge of each other than they might want to use extensions that are locally defined, lets's call those private extensions for which there is no direct need for globally accessible documentation. 

If the specification is not globally accessible than you may want to consider pointers from a global repository (e.g. IANA) to that specification. If the specification is non-existent or not accessible then just claiming the object name to avoid confusion is useful. That could be done in an IANA registry, or with a standardized private naming scheme.

If the WG things this is a useful qualification we can work out how to deal with these different classes.

--Olaf
  WEIRDS CO-Chair.

[1] http://www.ietf.org/mail-archive/web/weirds/current/msg01225.html

_______________________________________________________ 
Olaf Kolkman -- NLnet Labs
http://www.nlnetlabs.nl/